#include <iostream>
#include <vector>
#include <cstdio>  
#include <cstdlib>
#include <queue>
#include <cassert>
#include <set>
#include <algorithm>

using namespace std;

int n, p, k, x;

int main(int argc, char** argv)
{
	n = atoi(argv[1]);
	p = atoi(argv[2]);
	srand(atoi(argv[3]));
	
	vector<int> a(n), b(n), h(n), deg(n);
	vector<int> perm(n);
	int mx = 0, mxi = 0;
   	int i;
	for (i = 1; i < n-1; i++) {
	    a[i] = rand() % i;
	    h[i] = h[a[i]] + 1;
	    deg[a[i]]++;
	    if (h[i] > mx) {
	        mx = h[i];
	        mxi = i;
	    }
	}
	a[n-1] = mxi;
	deg[mxi]++;
	
    vector<int> lst;
	for (i = 0; i < n; i++) {
	    if (!deg[i])
	        lst.push_back(i);
	}
	
	for (i = 0; i < n; i++) {
	    perm[i] = i+1;
	}
	/*for (i = 0; i < n; i++) {
	    swap(perm[rand() % n], perm[rand() % n]);
	}*/

    k = rand() % (p+1);
	cout << n << " " << p << " " << k << " " << perm[lst[rand() % lst.size()]] << endl;
	for (i = 1; i < n; i++) {
        cout << perm[i] << " " << perm[a[i]] << endl;
	}
	for (i = 1; i <= p; i++)  {
	    int u = rand() % n;
	    int v = u;
	    while (u == v) v = rand() % n;
	    cout << perm[u] << " " << perm[v] << endl;
	}
}
