#include <cstdio>
#include <cstdlib>
#include <iostream>

using namespace std;

const int maxn = 200050;

int n, p, k, x;
int t, maxh;
int vis[maxn][11], d[maxn][11];
int u[maxn], v[maxn], g[maxn], nxt[maxn], type[maxn];
int l, r;
int qa[maxn*11], qb[maxn*11];

void dfs(int x, int h, int p)
{
    if (h > maxh) {
        maxh = h;
        t = x;
    }

    int i = g[x];
    while (i) {
        if (v[i] != p)
            dfs(v[i], h+1, x);
        i = nxt[i];
    }
}

void add(int i)
{
    nxt[i] = g[u[i]]; g[u[i]] = i;
}

int main()
{
    freopen("input.txt" ,"r", stdin); freopen("output.txt", "w", stdout);

    int i;

    cin >> n >> p >> k >> x;
    int m = 0;
    for (i = 1; i <= n-1; i++) {
        m++;
        cin >> u[m] >> v[m];
        add(m);
        m++;
        u[m] = v[m-1]; v[m] = u[m-1];
        add(m);
    }

    maxh = -1;
    dfs(1, 0, 0);

    for (i = 1; i <= p; i++) {
        m++;
        cin >> u[m] >> v[m];
        type[m] = 1;
        add(m);
        m++;
        u[m] = v[m-1]; v[m] = u[m-1];
        type[m] = 1;
        add(m);
    }

    vis[x][0] = 1;
    l = r = 0;
    qa[0] = x; qb[0] = 0;
    while (l <= r) {
        if (x == t) break;

        i = g[qa[l]];
        while (i) {
            if (!vis[v[i]][qb[l] + type[i]]) {
                vis[v[i]][qb[l] + type[i]] = 1;
                d[v[i]][qb[l] + type[i]] = d[qa[l]][qb[l]] + 1;
                r++;
                qa[r] = v[i];
                qb[r] = qb[l] + type[i];
            }
            i = nxt[i];
        }
        l++;
    }

    int best = n;
    for (i = 0; i <= k; i++) {
        if (vis[t][i] && d[t][i] < best)
            best = d[t][i];
    }
    cout << best << endl;

    fclose(stdin); fclose(stdout);
    return 0;
}
